#include <stdio.h>
#include <stdlib.h>

int main()
{
    int n,c,q;
    scanf("%d%d%d",&n,&c,&q);
    char *s=(char*)malloc(n*sizeof(char));
    scanf("%s",s);
    for (int i=0;i<q;i++)
    {
        int l,r;
        scanf("%d%d",&l,&r);
        for (int i=l-1;i<r;i++)
        {
            if (s[i]=='1') s[i]='0';
            else s[i]='1';
        }
        if (c==n)
        {
            int br=0;
            for (int i=0;i<n;i++) if (s[i]=='1') br++;
            printf("%d\n", br);
        }
    }
}